Index: trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90	(revision 3083)
@@ -20,6 +20,6 @@
       use comsaison_h, only: mu0, fract, dist_star, declin, right_ascen
       use comsoil_h, only: nsoilmx, layer, mlayer, inertiedat
-      use datafile_mod, only: datadir, corrkdir, banddir, haze_opt_file
-      use geometry_mod, only: latitude, longitude, cell_area
+      use datafile_mod, only: datadir, corrkdir, banddir, haze_opt_file, nudging_file
+      use geometry_mod, only: latitude, latitude_deg, longitude, cell_area
       USE comgeomfi_h, only: totarea, totarea_planet
       USE tracer_h
@@ -162,9 +162,11 @@
 !                + Titan's chemistry
 !           Microphysical moment model - J.Burgalat / J.Vatant d'Ollone (2017-2018)
+!           Improvement of microphysical moment model - B. de Batz de Trenquelléon (2022-2023)
+!           Optics ofnn Titan's coulds - B. de Batz de Trenquelléon (2022-2023)
 !============================================================================================
 
-
-!    0.  Declarations :
-!    ------------------
+! ---------------
+! 0. DECLARATIONS
+! ---------------
 
 include "netcdf.inc"
@@ -219,6 +221,6 @@
       real pw(ngrid,nlayer)               ! Vertical velocity (m/s). (NOTE : >0 WHEN DOWNWARDS !!)
 
-      integer l,ig,ierr,iq,nw,isoil
-      
+      integer l,ig,ierr,iq,nw,isoil,ilat,lat_idx,i,j
+
       ! FOR DIAGNOSTIC :
 
@@ -236,10 +238,12 @@
       real zdtsurf(ngrid)     ! Cumulated tendencies.
       real zdtsurfmr(ngrid)   ! Mass_redistribution routine.
+      real zdtsurfevap(ngrid) ! Evaporation.
       real zdtsdif(ngrid)     ! Turbdiff/vdifc routines.
             
       ! For Atmospheric Temperatures : (K/s)    
-      real zdtdif(ngrid,nlayer)                               ! Turbdiff/vdifc routines.
-      real zdtmr(ngrid,nlayer)                                ! Mass_redistribution routine.
-      real zdtsw1(ngrid,nlayer), zdtlw1(ngrid,nlayer)         ! Callcorrk routine.
+      real zdtdif(ngrid,nlayer)                       ! Turbdiff/vdifc routines.
+      real zdtmr(ngrid,nlayer)                        ! Mass_redistribution routine.
+      real zdtsw1(ngrid,nlayer), zdtlw1(ngrid,nlayer) ! Callcorrk routine.
+      real zdtlc(ngrid,nlayer)                        ! Condensation heating rate.
                               
       ! For Surface Tracers : (kg/m2/s)
@@ -267,4 +271,5 @@
       real zdhdif(ngrid,nlayer)                      ! Turbdiff/vdifc routines.
       real zdhadj(ngrid,nlayer)                      ! Convadj routine.
+      real zdundg(ngrid,nlayer)                      ! Nudging for zonal wind (m/s/s).
      
       ! For Pressure and Mass :
@@ -296,5 +301,5 @@
       real zdudyn(ngrid,nlayer)                          ! Dynamical Zonal Wind tendency (m.s-2).
 
-      real zhorizwind(ngrid,nlayer) ! Horizontal Wind ( sqrt(u**+v*v))
+      real zhorizwind(ngrid,nlayer) ! Horizontal Wind ( sqrt(u*u+v*v))
 
       real vmr(ngrid,nlayer)                        ! volume mixing ratio
@@ -303,5 +308,5 @@
       real ISR,ASR,OLR,GND,DYN,GSR,Ts1,Ts2,Ts3,TsS ! for Diagnostic.
       
-!     to test energy conservation (RW+JL)
+      ! To test energy conservation (RW+JL)
       real mass(ngrid,nlayer),massarea(ngrid,nlayer)
       real dEtot, dEtots, AtmToSurf_TurbFlux
@@ -311,10 +316,7 @@
       real dEdiffs(ngrid),dEdiff(ngrid)
       
-!JL12 conservation test for mean flow kinetic energy has been disabled temporarily
-
+      ! JL12 : conservation test for mean flow kinetic energy has been disabled temporarily
       real dItot, dItot_tmp, dVtot, dVtot_tmp
-      
       real dWtot, dWtot_tmp, dWtots, dWtots_tmp
-      
       
       ! For Clear Sky Case.
@@ -327,5 +329,4 @@
       character(len=10) :: tmp1
       character(len=10) :: tmp2
-      
       character*2 :: str2
 
@@ -338,18 +339,21 @@
 !$OMP THREADPRIVATE(ctimestep)
  
-      ! Chemical tracers in molar fraction 
-      real, dimension(ngrid,nlayer,nkim)          :: ychim ! (mol/mol)
-      real, dimension(ngrid,nlayer,nkim)          :: ychimbar ! For 2D chemistry
-
-      ! Molar fraction tendencies ( chemistry, condensation and evaporation ) for tracers (mol/mol/s)
-      real, dimension(ngrid,nlayer,nq)            :: dyccond        ! Condensation rate. NB : for all tracers, as we want to use indx on it.
-      real, dimension(ngrid,nlayer,nq)            :: dyccondbar     ! For 2D chemistry
-      real, dimension(ngrid)                      :: dycevapCH4     ! Surface "pseudo-evaporation" rate (forcing constant surface humidity).
-
-      ! Saturation profiles
-      real, dimension(ngrid,nlayer,nkim)          :: ysat ! (mol/mol)
-
-
-      real :: i2e(ngrid,nlayer)      ! int 2 ext factor ( X.kg-1 -> X.m-3 for diags )
+      ! Chemical tracers in molar fraction [mol/mol]
+      real, dimension(ngrid,nlayer,nkim) :: ychim
+      real, dimension(ngrid,nlayer,nkim) :: ychimbar ! For 2D chemistry
+
+      ! Molar fraction tendencies (chemistry, condensation and evaporation) for tracers [mol/mol/s]
+      real, dimension(ngrid,nlayer,nq)              :: dyccond    ! Condensation rate. NB : for all tracers, as we want to use indx on it.
+      real, dimension(ngrid,nlayer,size(ices_indx)) :: dmuficond  ! Condensation rate from microphysics [kg/kg/s].
+      real, dimension(ngrid,nlayer,nq)              :: dyccondbar ! For 2D chemistry
+      real, dimension(ngrid)                        :: dycevapCH4 ! Surface "pseudo-evaporation" rate for CH4.
+
+      ! Saturation profiles [mol/mol]
+      real, dimension(ngrid,nlayer,nkim) :: ysat
+      
+      ! Fraction of CH4 [mol/mol]
+      real, dimension(ngrid,nlayer) :: tpq_CH4
+
+      real :: i2e(ngrid,nlayer) ! int 2 ext factor (X.kg-1 -> X.m-3)
 
 #ifdef USE_QTEST
@@ -411,7 +415,12 @@
 !        ~~~~~~~~~~~~~~~~~~
          dtrad(:,:) = 0.D0
+         zdtlc(:,:) = 0.D0
          fluxrad(:) = 0.D0
          zdtsw(:,:) = 0.D0
          zdtlw(:,:) = 0.D0
+         zpopthi(:,:,:,:) = 0.D0
+         zpopthv(:,:,:,:) = 0.D0
+         zpoptci(:,:,:,:) = 0.D0
+         zpoptcv(:,:,:,:) = 0.D0
 
 !        Initialize setup for correlated-k radiative transfer
@@ -440,5 +449,5 @@
 #ifndef MESOSCALE 
            IF (callmufi .AND. (.NOT. uncoupl_optic_haze)) THEN
-             haze_opt_file=trim(datadir)//'/HAZE_OPTIC_'//trim(adjustl(tmp1))//'x'//trim(adjustl(tmp2))//'.DAT'
+             haze_opt_file=trim(datadir)//'/optical_tables/HAZE_OPTIC_'//trim(adjustl(tmp1))//'x'//trim(adjustl(tmp2))//'.DAT'
              inquire(file=trim(haze_opt_file),exist=file_ok)
              if(.not.file_ok) then
@@ -579,4 +588,22 @@
          endif
 
+         ! Read SuperNudging.dat and initialize the nudging for pu
+         ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+         if (nudging_u) then
+            nudging_file=trim(datadir)//'/SuperNudging.dat'
+            inquire(file=trim(nudging_file),exist=file_ok)
+            if(.not.file_ok) then
+               write(*,*) 'ERROR : The file ',TRIM(nudging_file),' was not found by physiq_mod.F90 ! Check in ', TRIM(datadir)
+               write(*,*) 'Meanwhile I abort ...'
+               call abort
+            endif
+            
+            open(88,file=nudging_file,form='formatted')
+            do ilat = 1, 49
+               read(88,*) u_ref(ilat,:)
+            enddo
+            close(88)
+         endif
+
 #ifndef MESOSCALE
          if (ngrid.ne.1) then ! Note : no need to create a restart file in 1d.
@@ -609,14 +636,15 @@
       ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-      pdt(:,:)    = 0.D0     
-      zdtsurf(:)  = 0.D0
-      pdq(:,:,:)  = 0.D0
-      dqsurf(:,:) = 0.D0
-      pdu(:,:)    = 0.D0
-      pdv(:,:)    = 0.D0
-      pdpsrf(:)   = 0.D0
-      zflubid(:)  = 0.D0      
-      taux(:)     = 0.D0
-      tauy(:)     = 0.D0
+      pdt(:,:)       = 0.D0     
+      zdtsurf(:)     = 0.D0
+      zdtsurfevap(:) = 0.D0
+      pdq(:,:,:)     = 0.D0
+      dqsurf(:,:)    = 0.D0
+      pdu(:,:)       = 0.D0
+      pdv(:,:)       = 0.D0
+      pdpsrf(:)      = 0.D0
+      zflubid(:)     = 0.D0      
+      taux(:)        = 0.D0
+      tauy(:)        = 0.D0
 
       zday=pday+ptime ! Compute time, in sols (and fraction thereof).
@@ -788,4 +816,5 @@
                call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
                             ztim1,ztim2,ztim3,mu0,fract, flatten)
+            
             else if(diurnal .eqv. .false.) then
 
@@ -810,11 +839,12 @@
 
                ! standard callcorrk
-               call callcorrk(ngrid,nlayer,pq,nq,qsurf,zday,                     &
-                              albedo,albedo_equivalent,emis,mu0,pplev,pplay,pt,   &
-                              tsurf,fract,dist_star,                              &
+               call callcorrk(ngrid,nlayer,pq,nq,qsurf,zday,                      &
+                              albedo,albedo_equivalent,emis,mu0,pplev,pplay,zzlev,&
+                              pt,tsurf,fract,dist_star,                           &
                               zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,                &
                               fluxsurfabs_sw,fluxtop_lw,                          &
                               fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,                &
-                              int_dtaui,int_dtauv,lastcall)
+                              int_dtaui,int_dtauv,zpopthi,zpopthv,zpoptci,zpoptcv,&
+                              lastcall)
 
                ! Radiative flux from the sky absorbed by the surface (W.m-2).
@@ -941,5 +971,6 @@
            pdt(:,:)=pdt(:,:)+zdtdif(:,:)
          endif
-           zdtsurf(:)=zdtsurf(:)+zdtsdif(:)
+         
+         zdtsurf(:)=zdtsurf(:)+zdtsdif(:)
 
          if (tracer) then 
@@ -1066,12 +1097,28 @@
             !        - Weird unphysical ratio of m0 and m3, ok for now, but take care of them if
             !          you want to compute optics from radii.
-            WHERE ( (pq(:,:,1)+pdq(:,:,1)*ptimestep < 0.D0) .OR. (pq(:,:,2)+pdq(:,:,2)*ptimestep < 0.D0) )
-                    pdq(:,:,1) = (epsilon(1.0)-1.D0)*pq(:,:,1)/ptimestep 
-                    pdq(:,:,2) = (epsilon(1.0)-1.D0)*pq(:,:,2)/ptimestep
+            WHERE ((pq(:,:,1)+pdq(:,:,1)*ptimestep < 0.D0) .OR. (pq(:,:,2)+pdq(:,:,2)*ptimestep < 0.D0))
+               pdq(:,:,1) = (epsilon(1.0)-1.D0)*pq(:,:,1)/ptimestep 
+               pdq(:,:,2) = (epsilon(1.0)-1.D0)*pq(:,:,2)/ptimestep
             ENDWHERE 
-            WHERE ( (pq(:,:,3)+pdq(:,:,3)*ptimestep < 0.D0) .OR. (pq(:,:,4)+pdq(:,:,4)*ptimestep < 0.D0) )
-                    pdq(:,:,3) = (epsilon(1.0)-1.D0)*pq(:,:,3)/ptimestep 
-                    pdq(:,:,4) = (epsilon(1.0)-1.D0)*pq(:,:,4)/ptimestep
+            WHERE ((pq(:,:,3)+pdq(:,:,3)*ptimestep < 0.D0) .OR. (pq(:,:,4)+pdq(:,:,4)*ptimestep < 0.D0))
+               pdq(:,:,3) = (epsilon(1.0)-1.D0)*pq(:,:,3)/ptimestep 
+               pdq(:,:,4) = (epsilon(1.0)-1.D0)*pq(:,:,4)/ptimestep
             ENDWHERE
+            IF (callclouds) THEN
+               WHERE ((pq(:,:,5)+pdq(:,:,5)*ptimestep < 0.D0) .OR. (pq(:,:,6)+pdq(:,:,6)*ptimestep < 0.D0))
+                  pdq(:,:,5) = (epsilon(1.0)-1.D0)*pq(:,:,5)/ptimestep
+                  pdq(:,:,6) = (epsilon(1.0)-1.D0)*pq(:,:,6)/ptimestep
+               ENDWHERE
+               DO iq = 1, size(ices_indx)
+                  ! For ices :
+                  WHERE (pq(:,:,ices_indx(iq))+pdq(:,:,ices_indx(iq))*ptimestep < 0.D0)
+                     pdq(:,:,ices_indx(iq)) = (epsilon(1.0)-1.D0)*pq(:,:,ices_indx(iq))/ptimestep
+                  ENDWHERE
+                  ! For gases :
+                  WHERE (pq(:,:,gazs_indx(iq))+pdq(:,:,gazs_indx(iq))*ptimestep < 0.D0)
+                     pdq(:,:,gazs_indx(iq)) = (epsilon(1.0)-1.D0)*pq(:,:,gazs_indx(iq))/ptimestep
+                  ENDWHERE
+               ENDDO
+            ENDIF
 #endif
 
@@ -1083,5 +1130,14 @@
               ! TODO : Add a sanity check here !
             endif
-
+         
+            ! >>> TEMPO : BBT
+            ! Default value -> no condensation [kg/kg_air/s] :
+            dmuficond(:,:,:) = 0.D0
+            do iq = 1, size(ices_indx)
+               dmuficond(:,:,iq) = zdqmufi(:,:,gazs_indx(iq))
+            enddo
+            call cond_muphy(ngrid,nlayer,pt,dmuficond,zdtlc)
+            !pdt(:,:) = pdt(:,:) + zdtlc(:,:)
+            ! <<< TEMPO : BBT
          endif
       
@@ -1099,5 +1155,5 @@
             ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             do iq = 1,nkim
-               ychim(:,:,iq) = ( pq(:,:,iq+nmicro) + pdq(:,:,iq+nmicro) ) / rat_mmol(iq+nmicro)
+               ychim(:,:,iq) = ( pq(:,:,iq+nmicro) + pdq(:,:,iq+nmicro)*ptimestep ) / rat_mmol(iq+nmicro)
             enddo
 
@@ -1110,5 +1166,5 @@
                 ychimbar(:,:,iq) =  zqfibar(:,:,iq+nmicro) / rat_mmol(iq+nmicro)
                   if ( callclouds ) then
-                    ychimbar(:,:,iq) =  ychimbar(:,:,iq) + ( zdqmufibar(:,:,iq+nmicro) / rat_mmol(iq+nmicro) )
+                    ychimbar(:,:,iq) =  ychimbar(:,:,iq) + ( zdqmufibar(:,:,iq+nmicro)*ptimestep / rat_mmol(iq+nmicro) )
                   endif
               enddo
@@ -1127,8 +1183,12 @@
             enddo
 
-            if ( callclouds ) dyccond(:,:,ices_indx) = 0.D0 ! Condensation have been calculated in the cloud microphysics 
+            if (callclouds) then
+               do iq = 1, size(ices_indx)
+                  dyccond(:,:,gazs_indx(iq)) = 0.D0 ! Condensation have been calculated in the cloud microphysics 
+               enddo
+            endif
 
             do iq=1,nkim
-              ychim(:,:,iq) = ychim(:,:,iq) + dyccond(:,:,iq+nmicro) ! update molar ychim for following calchim
+              ychim(:,:,iq) = ychim(:,:,iq) + dyccond(:,:,iq+nmicro)*ptimestep ! update molar ychim for following calchim
 
               pdq(:,:,iq+nmicro) = pdq(:,:,iq+nmicro) + dyccond(:,:,iq+nmicro)*rat_mmol(iq+nmicro) ! convert tendencies to mass mixing ratio
@@ -1149,14 +1209,18 @@
               enddo
 
-              if ( callclouds ) dyccondbar(:,:,ices_indx) = 0.D0 ! Condensation have been calculated in the cloud microphysics 
+               if (callclouds) then
+                  do iq = 1, size(ices_indx)
+                     dyccondbar(:,:,gazs_indx(iq)) = 0.D0 ! Condensation have been calculated in the cloud microphysics 
+                  enddo
+               endif
 
               do iq=1,nkim
-                ychimbar(:,:,iq) = ychimbar(:,:,iq) + dyccondbar(:,:,iq+nmicro)
+                ychimbar(:,:,iq) = ychimbar(:,:,iq) + dyccondbar(:,:,iq+nmicro)*ptimestep
               enddo
 
               ! Pseudo-evap ( forcing constant surface humidity )
-              do ig=1,ngrid
-                 if ( ychimbar(ig,1,7) .lt. botCH4 ) ychimbar(ig,1,7) = botCH4
-              enddo
+              !do ig=1,ngrid
+              !   if ( ychimbar(ig,1,7) .lt. botCH4 ) ychimbar(ig,1,7) = botCH4
+              !enddo
 
             endif ! if ( moyzon_ch .and. mod(icount-1,ichim).eq. 0 )
@@ -1182,11 +1246,26 @@
             ! iv. Surface pseudo-evaporation
             ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-            do ig=1,ngrid
-               if ( (ychim(ig,1,7)+dycchi(ig,1,7)*ptimestep) .lt. botCH4 ) then ! +dycchi because ychim not yet updated
-                  dycevapCH4(ig) = ( -ychim(ig,1,7)+botCH4 ) / ptimestep - dycchi(ig,1,7)
-               else
-                  dycevapCH4(ig) = 0.D0
-               endif
-            enddo
+            if (resCH4_inf) then
+                do ig=1,ngrid
+                        if ( (ychim(ig,1,7)+dycchi(ig,1,7)*ptimestep) .lt. botCH4 ) then ! + dycchi because ychim not yet updated
+                                dycevapCH4(ig) = ( -ychim(ig,1,7)+botCH4 ) / ptimestep - dycchi(ig,1,7)
+                        else
+                                dycevapCH4(ig) = 0.D0
+                        endif
+                enddo
+
+            ! >>> New evaporation flux
+            else
+                tankCH4(:) = 2. ! Pour le moment reservoir infini...
+                if (moyzon_ch) then
+                    tpq_CH4(:,:) = ychimbar(:,:,7) + dycchi(:,:,7)*ptimestep ! + dycchi because ychim not yet updated [mol/mol]
+                else
+                    tpq_CH4(:,:) = ychim(:,:,7) + dycchi(:,:,7)*ptimestep    ! + dycchi because ychim not yet updated [mol/mol]
+                endif
+                call evapCH4(ngrid,nlayer,ptimestep,pplev,zzlay,zzlev,&
+                             pu,pv,tsurf,tpq_CH4,tankCH4,dycevapCH4,zdtsurfevap)
+                zdtsurf(:) = zdtsurf(:) + zdtsurfevap(:)
+            endif
+            ! <<< New evaporation flux
 
             pdq(:,1,7+nmicro) = pdq(:,1,7+nmicro) + dycevapCH4(:)*rat_mmol(7+nmicro)
@@ -1204,5 +1283,5 @@
 
             pdq(:,:,:) = pdq(:,:,:) + zdqchi(:,:,:)
-            
+
          endif ! end of 'callchim'
 
@@ -1237,6 +1316,4 @@
             pdv(:,:)    = pdv(:,:)    + zdvmr(:,:)
             pdpsrf(:)   = pdpsrf(:)   + zdpsrfmr(:)
-            zdtsurf(:)  = zdtsurf(:)  + zdtsurfmr(:)
-            
          endif
 
@@ -1280,5 +1357,26 @@
 !   VII. Perform diagnostics and write output files
 !---------------------------------------------------
-
+      
+      ! Nudging of zonal wind !
+      ! ~~~~~~~~~~~~~~~~~~~~~~~
+      if (nudging_u) then
+         zdundg(:,:) = 0.D0
+         
+         ! boucle sur les points de grille :
+         do i = 1, ngrid
+            ! boucle sur les latitudes :
+            do j = 1, 49
+
+               ! Nudging of the first 23 layers only !!
+               if (ABS(REAL(u_ref(j,1)) - REAL(latitude_deg(i))) .lt. 1e-2) then
+                  zdundg(i,1:23) = (u_ref(j,2:24) - (pu(i,1:23)+pdu(i,1:23)*ptimestep)) / nudging_dt
+               endif
+            
+            enddo
+         enddo
+
+         pdu(:,:) = pdu(:,:) + zdundg(:,:)
+      endif
+       
       ! Note : For output only: the actual model integration is performed in the dynamics.
  
@@ -1309,9 +1407,13 @@
 
       ! Tracers.
+      ! >>> TEMPO : BBT
+      pdq(:,1:13,gazs_indx(2)) = (2e-8 - pq(:,1:13,gazs_indx(2))) / (ptimestep * 100)  ! C2H6
+      pdq(:,1:12,gazs_indx(3)) = (1e-9 - pq(:,1:12,gazs_indx(3))) / (ptimestep * 100)  ! C2H2
+      pdq(:,1:11,gazs_indx(4)) = (1e-20 - pq(:,1:11,gazs_indx(4))) / (ptimestep * 100) ! HCN
+      ! <<< TEMPO : BBT
       zq(:,:,:) = pq(:,:,:) + pdq(:,:,:)*ptimestep
 
       ! Surface pressure.
       ps(:) = pplev(:,1) + pdpsrf(:)*ptimestep
-
 
 
@@ -1454,43 +1556,29 @@
       call writediagfi(ngrid,"p","Pressure","Pa",3,pplay)
 
-!     Subsurface temperatures
-!        call writediagsoil(ngrid,"tsurf","Surface temperature","K",2,tsurf)
-!        call writediagsoil(ngrid,"temp","temperature","K",3,tsoil)
-
-      
-
       ! Total energy balance diagnostics
       if(callrad.and.(.not.newtonian))then
-      
-         !call writediagfi(ngrid,"ALB","Surface albedo"," ",2,albedo_equivalent)
+         call writediagfi(ngrid,"ALB","Surface albedo"," ",2,albedo_equivalent)
          call writediagfi(ngrid,"ISR","incoming stellar rad.","W m-2",2,fluxtop_dn)
          call writediagfi(ngrid,"ASR","absorbed stellar rad.","W m-2",2,fluxabs_sw)
          call writediagfi(ngrid,"OLR","outgoing longwave rad.","W m-2",2,fluxtop_lw)
          
-!           call writediagfi(ngrid,"ASRcs","absorbed stellar rad (cs).","W m-2",2,fluxabs_sw1)
-!           call writediagfi(ngrid,"OLRcs","outgoing longwave rad (cs).","W m-2",2,fluxtop_lw1)
-!           call writediagfi(ngrid,"fluxsurfsw","sw surface flux.","W m-2",2,fluxsurf_sw)
-!           call writediagfi(ngrid,"fluxsurflw","lw back radiation.","W m-2",2,fluxsurf_lw)
-!           call writediagfi(ngrid,"fluxsurfswcs","sw surface flux (cs).","W m-2",2,fluxsurf_sw1)
-!           call writediagfi(ngrid,"fluxsurflwcs","lw back radiation (cs).","W m-2",2,fluxsurf_lw1)
-
-
-         call writediagfi(ngrid,"GND","heat flux from ground","W m-2",2,fluxgrd)
-         
+         call writediagfi(ngrid,"ASRcs","absorbed stellar rad (cs).","W m-2",2,fluxabs_sw1)
+         call writediagfi(ngrid,"OLRcs","outgoing longwave rad (cs).","W m-2",2,fluxtop_lw1)
+         call writediagfi(ngrid,"fluxsurfsw","sw surface flux.","W m-2",2,fluxsurf_sw)
+         call writediagfi(ngrid,"fluxsurflw","lw back radiation.","W m-2",2,fluxsurf_lw)
+         call writediagfi(ngrid,"fluxsurfswcs","sw surface flux (cs).","W m-2",2,fluxsurf_sw1)
+         call writediagfi(ngrid,"fluxsurflwcs","lw back radiation (cs).","W m-2",2,fluxsurf_lw1)
+
+         call writediagfi(ngrid,"GND","heat flux from ground","W m-2",2,fluxgrd)         
          call writediagfi(ngrid,"DYN","dynamical heat input","W m-2",2,fluxdyn)
-         
       endif ! end of 'callrad'
         
       if(enertest) then
-      
          if (calldifv) then
-         
             call writediagfi(ngrid,"q2","turbulent kinetic energy","J.kg^-1",3,q2)
             call writediagfi(ngrid,"sensibFlux","sensible heat flux","w.m^-2",2,sensibFlux)
-            
-!             call writediagfi(ngrid,"dEzdiff","turbulent diffusion heating (-sensible flux)","w.m^-2",3,dEzdiff)
-!             call writediagfi(ngrid,"dEdiff","integrated turbulent diffusion heating (-sensible flux)","w.m^-2",2,dEdiff)
-!             call writediagfi(ngrid,"dEdiffs","In TurbDiff (correc rad+latent heat) surf nrj change","w.m^-2",2,dEdiffs)
-             
+            call writediagfi(ngrid,"dEzdiff","turbulent diffusion heating (-sensible flux)","w.m^-2",3,dEzdiff)
+            call writediagfi(ngrid,"dEdiff","integrated turbulent diffusion heating (-sensible flux)","w.m^-2",2,dEdiff)
+            call writediagfi(ngrid,"dEdiffs","In TurbDiff (correc rad+latent heat) surf nrj change","w.m^-2",2,dEdiffs) 
          endif
           
@@ -1499,33 +1587,31 @@
             call writediagfi(ngrid,"dEzradlw","radiative heating","w.m^-2",3,dEzradlw)
          endif
-          
       endif ! end of 'enertest'
 
-        ! Diagnostics of optical thickness
-        ! Warning this is exp(-tau), I let you postproc with -log to have tau itself - JVO 19
-        if (diagdtau) then                
-          do nw=1,L_NSPECTV
+      ! Diagnostics of optical thickness
+      ! Warning this is exp(-tau), I let you postproc with -log to have tau itself - JVO 19
+      if (diagdtau) then                
+         do nw=1,L_NSPECTV
             write(str2,'(i2.2)') nw
             call writediagfi(ngrid,'dtauv'//str2,'Layer optical thickness attenuation in VI band '//str2,'',1,int_dtauv(:,nlayer:1:-1,nw))
-          enddo
-          do nw=1,L_NSPECTI
+         enddo
+         do nw=1,L_NSPECTI
             write(str2,'(i2.2)') nw
             call writediagfi(ngrid,'dtaui'//str2,'Layer optical thickness attenuation in IR band '//str2,'',1,int_dtaui(:,nlayer:1:-1,nw))
-          enddo
-        endif
-
-        ! Temporary inclusions for winds diagnostics.
-        call writediagfi(ngrid,"zdudif","Turbdiff tend. zon. wind","m s-2",3,zdudif)
-        call writediagfi(ngrid,"zdudyn","Dyn. tend. zon. wind","m s-2",3,zdudyn)
-
-        ! Temporary inclusions for heating diagnostics.
-        call writediagfi(ngrid,"zdtsw","SW heating","T s-1",3,zdtsw)
-        call writediagfi(ngrid,"zdtlw","LW heating","T s-1",3,zdtlw)
-        call writediagfi(ngrid,"dtrad","radiative heating","K s-1",3,dtrad)
-        call writediagfi(ngrid,"zdtdyn","Dyn. heating","T s-1",3,zdtdyn)
+         enddo
+      endif
+
+      ! Temporary inclusions for winds diagnostics.
+      call writediagfi(ngrid,"zdudif","Turbdiff tend. zon. wind","m s-2",3,zdudif)
+      call writediagfi(ngrid,"zdudyn","Dyn. tend. zon. wind","m s-2",3,zdudyn)
+
+      ! Temporary inclusions for heating diagnostics.
+      call writediagfi(ngrid,"zdtsw","SW heating","T s-1",3,zdtsw)
+      call writediagfi(ngrid,"zdtlw","LW heating","T s-1",3,zdtlw)
+      call writediagfi(ngrid,"dtrad","radiative heating","K s-1",3,dtrad)
+      call writediagfi(ngrid,"zdtdyn","Dyn. heating","T s-1",3,zdtdyn)
         
-        ! For Debugging.
-        call writediagfi(ngrid,'pphi','Geopotential',' ',3,pphi)
-        
+      ! For Debugging.
+      call writediagfi(ngrid,'pphi','Geopotential',' ',3,pphi)
 
       ! Output tracers.
@@ -1561,5 +1647,4 @@
             call writediagfi(ngrid,"mmd_rc_sph","Spherical mode caracteristic radius",'m',3,mmd_rc_sph)
             call writediagfi(ngrid,"mmd_rc_fra","Fractal mode caracteristic radius",'m',3,mmd_rc_fra)
-
          endif ! end of 'callmufi'
 
@@ -1568,4 +1653,5 @@
            do iq=1,nkim
              call writediagfi(ngrid,cnames(iq),cnames(iq),'mol/mol',3,zq(:,:,iq+nmicro)/rat_mmol(iq+nmicro))
+             call writediagfi(ngrid,'dqcond_'//cnames(iq),'dqcond_'//cnames(iq),'mol/mol/s',3,dyccond(:,:,iq+nmicro))
            enddo
            call writediagfi(ngrid,"evapCH4","Surface CH4 pseudo-evaporation rate",'mol/mol/s',2,dycevapCH4)
@@ -1574,8 +1660,14 @@
        endif ! end of 'tracer'
 
+#ifdef CPP_XIOS
+!-----------------------------------------------------------------------------------------------------
 ! XIOS outputs
-#ifdef CPP_XIOS      
+!-----------------------------------------------------------------------------------------------------
       ! Send fields to XIOS: (NB these fields must also be defined as
       ! <field id="..." /> in context_lmdz_physics.xml to be correctly used)
+      
+      !--------------------------------------------------------
+      ! General diagnostics :
+      !--------------------------------------------------------
       CALL send_xios_field("ls",zls*180./pi)
       CALL send_xios_field("lss",zlss*180./pi)
